#include "Object2D.h"
#include "Scene2D.h"

Object2D::Object2D(Scene2D * scene, int layer )
:	scene( scene ),
	pos_layer( layer ),
	pos_x( 0 ),
	pos_y( 0 )
{
	scene->add_object2d( this );
}

Object2D::~Object2D()
{
	scene->remove_object2d( this );
}

int Object2D::get_x()const
{
	return pos_x;
}
int Object2D::get_y()const
{
	return pos_y;
}
int Object2D::get_layer()const
{
	return pos_layer;
}

void Object2D::move(int x, int y)
{
	pos_x = x;
	pos_y = y;
}

void Object2D::change_layer(int layer)
{
	if( layer != pos_layer )
	{
		scene->remove_object2d( this );
		pos_layer = layer;
		scene->add_object2d( this );
	}
}
