#ifndef AUTOPTR_H
#define AUTOPTR_H

#include <Nocopy.h>

template<typename T>
class AutoPtr
{
	const AutoPtr & operator=(const AutoPtr & );
public:
	AutoPtr( T * ptr = 0)
		:	ptr( ptr )
	{}
	//      BCC5.5,  
	//  ,     
	AutoPtr(const AutoPtr & au)
		:	ptr( au.ptr )
	{
		au.ptr = 0;
	}
	~AutoPtr()
	{
		delete ptr; ptr = 0;
	}
	T * operator->()const
	{
		return ptr;
	}
	T & operator*()const
	{
		return *ptr;
	}
	operator T *()const
	{
		return ptr;
	}
private:
	T * ptr;
};

template<typename T>
class AutoVecPtr : private Nocopy
{
public:
	AutoVecPtr( T * ptr = 0)
		:	ptr( ptr )
	{}
	~AutoVecPtr()
	{
		delete [] ptr; ptr = 0;
	}
	operator T *()const
	{
		return ptr;
	}
private:
	T * ptr;
};

#endif //AUTOPTR_H